/* test.c --- 
 * 
 * Filename: test.c
 * Author: Jules <archjules>
 * Created: Mon Apr 17 14:59:33 2017 (+0200)
 * Last-Updated: Thu Apr 20 15:31:15 2017 (+0200)
 *           By: Jules <archjules>
 */
#include <stdbool.h>
#include <display.h>
#include <keyboard.h>
#include <utils.h>
#include <tuto.h>
#include <game.h>

/*
 * Cette fonction permet de poser une question sur le choix politique
 * Les deux strings données représentent la question (une sur la ligne du haut,
 * une sur la ligne du bas). m représente la moyenne actuelle de la valeur qu'on
 * teste, n le nombre de questions déja posées sur la valeur qu'on teste,
 * et dir la direction dans laquelle les réponses vont.
 */
void ask_question(char * s1, char * s2, int * m, int * n, bool dir) {
    int choix = 0;
    int fleche_positions[] = {12, 42, 33, 15};
    key_t key = KEY_0;
    
    do {
	dclear();
	center(5, s1);
	center(11, s2);
	
	center(25, "Compl\x12tement d'accord");
	center(31, "D'accord");
	center(37, "En d\x13saccord");
	center(43, "En d\x13saccord complet");

	dprint(fleche_positions[choix], 25 + (choix * 6), "\x02");
       
	dupdate();
    } while(handle_input(&choix, 4) != 1);

    if (dir) choix = -choix + 3;
    if (choix > 1) choix++;
    (*m) = (((*m) * (*n)) + choix * 250) / (*n + 1);
    (*n)++;
}

/*
 * Fonction principale du test politique. Elle donne les
 * instructions et pose les questions, affiche le résultat,
 * puis lance le jec avec le résultat du test, en proposant
 * le test.
 */ 
void test_main() {
    int eco_mean = 0, eco_nb = 0,
	soc_mean = 0, soc_nb = 0,
	choix = 0, player;
    key_t key;
    dclear();
    
    center(10, "Pour vous placer, nous allons");
    center(16, "vous montrer quelques phrases.");
    center(25, "Des phrases s'afficheront à l'\x13""cran.");
    center(31, "Dites-nous \x10 quel point vous");
    center(37, "\x14tes d'accord avec elles.");

    dupdate();
    wait_input();

    ask_question(
	"Les taxes des entreprises",
	"devraient \x14tre minimales.",
	&eco_mean, &eco_nb, true);

    ask_question(
	"Les drogues r\x13""cr\x13""ationnelles",
	"devraient \x14tre l\x13gales.",
	&soc_mean, &soc_nb, false);

    ask_question(
	"Un citoyen doit toujours",
	"supporter son arm\x13""e.",
	&soc_mean, &soc_nb, true);

    ask_question(
	"Les impots devraient servir \x10",
	"aider ceux qui en ont besoin.",
	&eco_mean, &eco_nb, false);

    ask_question(
	"Le gouvernement ne devrait",
	"pas intervenir sur le march\x13.",
	&eco_mean, &eco_nb, true);

    ask_question(
	"La censure est parfois",
	"n\x13""cessaire.",
	&soc_mean, &soc_nb, true);

    ask_question(
	"L'avortement devrait",
	"\x14tre ill\x13gal.",
	&soc_mean, &soc_nb, true);

    ask_question(
	"Assurer des dividendes est",
	"le seul but d'une entreprise.",
	&eco_mean, &eco_nb, true);

    do {
	dclear();
	
	if (eco_mean < 500) {
	    if (soc_mean < 500) {
		center(5, "Les anarcho-communistes :");
		center(11, "Vous jouez Kropotkine.");
		player = 0;
	    } else {
		center(5, "Les stalinistes :");
		center(11, "Vous jouez Staline.");
		player = 1;
	    }
	} else {
	    if (soc_mean < 500) {
		center(5, "Les n\x13olib\x13raux :");
		center(11, "Vous jouez Keynes.");
		player = 2;
	    } else {
		center(5, "Les fascistes :");
		center(11, "Vous jouez Mussolini.");
		player = 3;
	    }
	}

	center(31, "Commencer");
	center(37, "Tutoriel");

	dprint((choix) ? 44 : 38, 31 + choix * 6, "\x02");
	
	dupdate();
    } while(handle_input(&choix, 2) != 1);

    if (choix)
	tuto_main();

    game_main(player);
}
